Release: Elastic Beanstalk launches Amazon Linux 2023 new platform releases and updates on January 25, 2024 - AWS Elastic Beanstalk

Release: Elastic Beanstalk launches Amazon Linux 2023 new platform releases and updates on January 25, 2024

Elastic Beanstalk releases new Amazon Linux 2023 platform branches for Corretto and Node.js. This release also includes updates for Docker, ECS based Docker, Go, Corretto, Tomcat, .NET Core, Python, and Ruby AL2023 platforms. It also provides Puma updates, AMI updates, and security updates.

Release date: January 25, 2024

Changes

The following table lists the changes included in this release.

Notes
  • These release notes focus on changes to currently supported platform branches. For full version information of Elastic Beanstalk retiring (deprecated) platform branches, see Elastic Beanstalk platform versions scheduled for retirement in the AWS Elastic Beanstalk Platforms guide.

  • Be aware that at the time these release notes are published, the new platform versions might not yet be available in all the AWS Regions that Elastic Beanstalk supports. It might take a few hours for the release to complete.

Category Description

Security updates

Applied all security updates published in the Amazon Linux Security Center on or before January 22, 2024 to all AL2023 platforms.

Cross-platform updates

Made these cross-platform updates:

Component Update

AMI

Updated the base AMI to version 2023.3.20240122.

CloudWatch

Updated CloudWatch Agent to version 1.300032.3.

Platform-specific updates

Made these platform-specific updates:

Platform Update

Docker

ECS Docker platform branch

  • Updated Amazon ECS Agent to version 1.80.0.

Docker platform branch

  • Updated Docker Compose to version 2.24.2.

Additional changes to the Docker platform branch with the release

  • These changes do not apply to the ECS Docker platform.

  • This release resolves an issue on the AL2023 Docker platform with container log generation when log files in the /var/lib/docker/containers directory are rotated. The fix adds a Docker daemon configuration file, daemon.json, to the Docker platform branch. The configuration results in the use of Docker’s built-in log rotation mechanism to prevent issues and redundancies with the logs.

  • This update causes a behavior change with the log publication to S3 functionality that's controlled by the LogPublicationControl option of the aws:elasticbeanstalk:hostmanager namespace. With the update introduced in this release, the rotated log files in the /var/lib/docker/containers directory will no longer be published to S3 buckets; however, rotated log files in the /var/log/eb-docker/containers/eb-current-app directory will continue to be published.

Go

Updated Go to release 1.20.12. For details, see go1.20.12 in The Go Programming Language Release History.

This is a security release.

Corretto

**New!** — Introduced new Corretto 21 platform branch running on AL2023: Corretto version 21.0.2.13.1.

Language runtime updates:

All of the language runtime updates are security releases.

Tomcat

Tomcat 9 platform branches

Tomcat 10 platform branches

All of the Corretto language runtime updates are security releases.

.NET Core

Updated .NET Core to release 6.0.26.

This is a security release.

Node.js

**New!** — Introduced new Node.js 20 platform branch running on AL2023: Node.js version 20.10.0.

For documentation of the latest version, see Node.js v20.x Documentation.

Important
  • If you migrate to the AL2023 Node.js 20 platform branch from a previous Node.js platform branch, such as AL2023 Node.js 18, your deployment may fail if you use custom deployment scripts that call npx. For more information, expand the AL2023 Node.js 20 note that follows this table.

  • The AL2023 platform update that has since been released on March 26, 2024 includes a symbolic link to remedy this issue.

Python

Updated Pipenv to release 2023.11.17 for both the Python 3.9 and Python 3.11 platform branches. For details, see the Pipenv Release and Version History.

Ruby

Updated Puma to version 6.4.2.

If you migrate to the AL2023 Node.js 20 platform branch from a previous Node.js platform branch, such as AL2023 Node.js 18, your deployment may fail if you use custom deployment scripts that call npx. This is because the default name of the npx command is different on the AL2023 Node.js 20 platform. The default name on this latest platform is npx-20, rather than npx.

The AL2023 platform update that has since been released on March 26, 2024 includes a symbolic link to remedy this issue.

Until you're able to update environment to the latest release, here are two workaround options to avoid deployment issues with your custom deployment scripts. We recommend using the second option for more flexibility, which uses a symbolic link.

  • Option 1 – Use npx-20 instead of npx in your scripts.

  • Option 2 Add a prebuild platform hook to create symbolic link to npx-20, (and continue to use the npx command name in your scripts).

    The following example script creates the symbolic link. Place this script file in the .platform/hooks/prebuild directory in your application, so that Elastic Beanstalk runs it in the prebuild phase of the deployment.

    This script creates a symbolic link to the required npx-20 command, if it cannot locate npx in the directory used by the previous Node.js platform branches. When it runs in the prebuild phase, it creates the symbolic link before the remainder of your configuration and deployment steps run. So any calls to npx that follow will direct to the npx-20 command for this platform branch.

    #!/usr/bin/env bash if [ ! -f /usr/bin/npx ]; then ln -s /usr/bin/npx-20 /usr/bin/npx fi npx -v

New platform versions

Notes
  • The following tables list all supported platform branches for each platform, including Amazon Linux 2. Only Amazon Linux 2023 platform branches are updated with this release.

  • The following tables list only supported platform branches. They do not list platform branches that are scheduled for retirement (deprecated). For full version information of Elastic Beanstalk retiring (deprecated) platform branches, see Elastic Beanstalk platform versions scheduled for retirement in the AWS Elastic Beanstalk Platforms guide.

Docker

Platform Version and Solution Stack Name

AMI

ECS Agent

Docker

Docker Compose

Proxy Server

Docker AL2023 version 4.2.0

64bit Amazon Linux 2023 v4.2.0 running Docker

2023.3.20240122

24.0.5-1

2.24.2

nginx 1.24.0

ECS AL2023 version 4.0.3

64bit Amazon Linux 2023 v4.0.3 running ECS

2023.3.20240122

1.80.0

Docker AL2 version 3.6.5

64bit Amazon Linux 2 v3.6.5 running Docker

2.0.20231206

20.10.25-1

2.23.3

nginx 1.22.1

ECS AL2 version 3.2.15

64bit Amazon Linux 2 v3.2.15 running ECS

2.0.20231206

1.79.1

Go

Platform Version and Solution Stack Name

AMI

Language

AWS X-Ray

Proxy Server

Go 1 AL2023 version 4.0.3

64bit Amazon Linux 2023 v4.0.3 running Go 1

2023.3.20240122

Go 1.20.12

3.2.0

nginx 1.24.0

Go 1 AL2 version 3.8.4

64bit Amazon Linux 2 v3.8.4 running Go 1

2.0.20231206

Go 1.21.5

3.2.0

nginx 1.22.1

Java SE

Platform Version and Solution Stack Name

AMI

Language

Tools

AWS X-Ray

Proxy Server

Corretto 21 AL2023 version 4.2.0

64bit Amazon Linux 2023 v4.2.0 running Corretto 21

2023.3.20240122

Corretto 21.0.2.13.1

Ant 1.10.12, Gradle 8.5, Maven 3.8.4

3.2.0

nginx 1.24.0

Corretto 17 AL2023 version 4.2.0

64bit Amazon Linux 2023 v4.2.0 running Corretto 17

2023.3.20240122

Corretto 17.0.10.7.1

Ant 1.10.12, Gradle 8.5, Maven 3.8.4

3.2.0

nginx 1.24.0

Corretto 11 AL2023 version 4.2.0

64bit Amazon Linux 2023 v4.2.0 running Corretto 11

2023.3.20240122

Corretto 11.0.22.7.1

Ant 1.10.12, Gradle 8.5, Maven 3.8.4

3.2.0

nginx 1.24.0

Corretto 8 AL2023 version 4.2.0

64bit Amazon Linux 2023 v4.2.0 running Corretto 8

2023.3.20240122

Corretto 8.402.08.1

Ant 1.10.12, Gradle 8.5, Maven 3.8.4

3.2.0

nginx 1.24.0

Corretto 17 version 3.6.2

64bit Amazon Linux 2 v3.6.2 running Corretto 17

2.0.20231206

Corretto 17.0.9.8.1

Ant 1.10.14, Gradle 8.5, Maven 3.9.6

3.2.0

nginx 1.22.1

Corretto 11 version 3.6.2

64bit Amazon Linux 2 v3.6.2 running Corretto 11

2.0.20231206

Corretto 11.0.21.9.1

Ant 1.10.14, Gradle 8.5, Maven 3.9.6

3.2.0

nginx 1.22.1

Corretto 8 version 3.6.2

64bit Amazon Linux 2 v3.6.2 running Corretto 8

2.0.20231206

Corretto 8.392.08.1

Ant 1.10.14, Gradle 8.5, Maven 3.9.6

3.2.0

nginx 1.22.1

Tomcat

Platform Version and Solution Stack Name

AMI

Language

AWS X-Ray

Application Server

Proxy Server

Corretto 17 with Tomcat 10 AL2023 version 5.1.3

64bit Amazon Linux 2023 v5.1.3 running Tomcat 10 Corretto 17

2023.3.20240122

Corretto 17.0.10.7.1

3.2.0

Tomcat 10.1.18

nginx 1.24.0 (default), Apache 2.4.58

Corretto 17 with Tomcat 9 AL2023 version 5.1.3

64bit Amazon Linux 2023 v5.1.3 running Tomcat 9 Corretto 17

2023.3.20240122

Corretto 17.0.10.7.1

3.2.0

Tomcat 9.0.82

nginx 1.24.0 (default), Apache 2.4.58

Corretto 11 with Tomcat 9 AL2023 version 5.1.3

64bit Amazon Linux 2023 v5.1.3 running Tomcat 9 Corretto 11

2023.3.20240122

Corretto 11.0.22.7.1

3.2.0

Tomcat 9.0.82

nginx 1.24.0 (default), Apache 2.4.58

.NET Core on Linux

Platform Version and Solution Stack Name

Framework

Proxy Server

AMI

AWS X-Ray

.NET 6 on AL2023 version 3.0.3

64bit Amazon Linux 2023 v3.0.3 running .NET 6

.NET 6.0.26, supports 6.0.26

nginx 1.24.0

2023.3.20240122

3.2.0

.NET Core on AL2 version 2.6.3

64bit Amazon Linux 2 v2.6.3 running .NET Core

.NET 6.0.25, supports 6.0.25

nginx 1.22.1

2.0.20231206

3.2.0

Node.js

Platform Version and Solution Stack Name

AMI

Node.js versions (npm versions)

Proxy Server

Git

AWS X-Ray

Node.js 20 AL2023 version 6.1.0

64bit Amazon Linux 2023 v6.1.0 running Node.js 20

2023.3.20240122

20.10.0 (10.2.3)

Default version: 20.10.0

nginx 1.24.0 (default), Apache 2.4.58

2.40.1

3.2.0

Node.js 18 AL2023 version 6.1.0

64bit Amazon Linux 2023 v6.1.0 running Node.js 18

2023.3.20240122

18.18.2 (9.8.1)

Default version: 18.18.2

nginx 1.24.0 (default), Apache 2.4.58

2.40.1

3.2.0

Node.js 18 AL2 version 5.8.9

64bit Amazon Linux 2 v5.8.9 running Node.js 18

2.0.20231206

18.19.0 (10.2.3), 18.18.2 (9.8.1), 18.18.1 (9.8.1), 18.18.0 (9.8.1), 18.17.1 (9.6.7), 18.17.0 (9.6.7), 18.16.1 (9.5.1), 18.16.0 (9.5.1), 18.15.0 (9.5.0), 18.14.2 (9.5.0), 18.14.1 (9.3.1), 18.14.0 (9.3.1), 18.13.0 (8.19.3), 18.12.1 (8.19.2), 18.12.0 (8.19.2), 18.11.0 (8.19.2), 18.10.0 (8.19.2), 18.9.1 (8.19.1), 18.9.0 (8.19.1), 18.8.0 (8.18.0), 18.7.0 (8.15.0), 18.6.0 (8.13.2), 18.5.0 (8.12.1), 18.4.0 (8.12.1), 18.3.0 (8.11.0), 18.2.0 (8.9.0), 18.1.0 (8.8.0), 18.0.0 (8.6.0)

Default version: 18.19.0

nginx 1.22.1 (default), Apache 2.4.58

2.40.1

3.2.0

PHP

Platform Version and Solution Stack Name

AMI

Language

Composer

Proxy Server

PHP 8.2 AL2023 version 4.0.5

64bit Amazon Linux 2023 v4.0.5 running PHP 8.2

2023.3.20240122

PHP 8.2.9

2.5.8

nginx 1.24.0 (default), Apache 2.4.58

PHP 8.1 AL2023 version 4.0.5

64bit Amazon Linux 2023 v4.0.5 running PHP 8.1

2023.3.20240122

PHP 8.1.23

2.5.7

nginx 1.24.0 (default), Apache 2.4.58

PHP 8.1 AL2 version 3.5.15

64bit Amazon Linux 2 v3.5.15 running PHP 8.1

2.0.20231206

PHP 8.1.26

2.3.5

nginx 1.22.1 (default), Apache 2.4.58

Python

Platform Version and Solution Stack Name

AMI

Language

Package Manager

Packager

meld3

AWS X-Ray

Proxy Server

Python 3.11 AL2023 version 4.0.8

64bit Amazon Linux 2023 v4.0.8 running Python 3.11

2023.3.20240122

Python 3.11.6

pipenv 2023.11.17

3.2.0

nginx 1.24.0 (default), Apache 2.4.58

Python 3.9 AL2023 version 4.0.8

64bit Amazon Linux 2023 v4.0.8 running Python 3.9

2023.3.20240122

Python 3.9.16

pipenv 2023.11.17

3.2.0

nginx 1.24.0 (default), Apache 2.4.58

Python 3.8 AL2 version 3.5.10

64bit Amazon Linux 2 v3.5.10 running Python 3.8

2.0.20231206

Python 3.8.16

pipenv 2023.11.15

3.2.0

nginx 1.22.1 (default), Apache 2.4.58

Ruby

Platform Version and Solution Stack Name

AMI

Language

Package Manager

Application Server

AWS X-Ray

Proxy Server

Ruby 3.2 AL2023 version 4.0.3

64bit Amazon Linux 2023 v4.0.3 running Ruby 3.2

2023.3.20240122

Ruby 3.2.2

RubyGems 3.4.10

Puma 6.4.2

3.2.0

nginx 1.24.0